/**
 * @file
 * Javascript needed inside the Opayo 3D secure iframe
 *
 */
(function (Drupal, once) {

  'use strict';

  /**
   * Attaches the Opayo3DSecure behavior.
   *
   * @type {Drupal~behavior}
   *
   * @prop {Drupal~behaviorAttach} attach
   *   Attaches the OpayoCheckout behavior.
   */
  Drupal.behaviors.Opayo3DSecure = {
    attach: function (context, settings) {

      once('Opayo3DSecureSuccess', '#commerce-opayo-3d-success', context).forEach((ele) => {
        // This is called from within the 3D Secure iFrame when the challenge has completed succesfully
        const message = JSON.stringify({
            result: 'success',
            date: Date.now(),
        });
        window.parent.postMessage(message, '*');
      }, context);

      once('Opayo3DSecureFailure', '#commerce-opayo-3d-failure', context).forEach((ele) => {
        // This is called from within the 3D Secure iFrame when the challenge has failed
        const message = JSON.stringify({
            result: 'failed',
            messageforuser: settings.commerceopayopi.opayo_3dsecure.message,
            date: Date.now(),
        });
        window.parent.postMessage(message, '*');
      }, context);
    }
  }


})(Drupal, once);
