<?php

namespace Drupal\commerce_opayo_pi\Resolvers;

use Drupal\commerce_checkout\Entity\CheckoutFlow;
use Drupal\commerce_checkout\Resolver\CheckoutFlowResolverInterface;
use Drupal\commerce_order\Entity\OrderInterface;

class OpayoCheckoutFlowResolver implements CheckoutFlowResolverInterface {

  /**
   * {@inheritdoc}
   */
  public function resolve(OrderInterface $order) {
      /** @var \Drupal\commerce_payment\PaymentGatewayStorageInterface $payment_gateway_storage */
      $payment_gateway_storage = \Drupal::entityTypeManager()->getStorage('commerce_payment_gateway');
      $payment_gateways = $payment_gateway_storage->loadMultipleForOrder($order);
      if (array_key_exists('opayo_pi', $payment_gateways)) {
        // Need to use a checkout flow that uses the 'Opayo checkout flow' plugin (which can handle 3DS challenge)
        $checkout_flows = CheckoutFlow::loadMultiple(null);
        foreach($checkout_flows as $checkout_flow) {
          if ($checkout_flow->getPluginId() == 'opayo_checkout_flow') {
            return $checkout_flow;
          }
        }
      }
  }
}
